Name "BPL"

OutFile "bpl-1.0.1-windows.exe"

!include "LogicLib.nsh"
!include "MUI.nsh"
!include "StrReplace.nsh"
!include "ReplaceInFile.nsh"

InstallDir $PROGRAMFILES\bpl

# registry key for installation directory
# InstallDirRegKey HKLM "Software\bpl-1.0.1" "Install_Dir"

# Pages

# !insertmacro MUI_PAGE_WELCOME
!insertmacro MUI_PAGE_COMPONENTS
!insertmacro MUI_PAGE_DIRECTORY
!insertmacro MUI_PAGE_INSTFILES

!define MUI_FINISHPAGE_TITLE "Installation (nearly) complete."
!define MUI_FINISHPAGE_TEXT "Note that you probably still want to add the BPL binary directory\r\n\r\n\t$INSTDIR\r\n\r\nto your PATH."

!insertmacro MUI_PAGE_FINISH

!insertmacro MUI_UNPAGE_CONFIRM
!insertmacro MUI_UNPAGE_INSTFILES

!insertmacro MUI_LANGUAGE "English"

Section "BPL" SecBPL

  SectionIn RO

  SetOutPath $INSTDIR

  File "/oname=bplc-bin.exe" ".\bplc.exe"
  File ".\System.bpl"
  File ".\bplc.bat"

  !insertmacro ReplaceInFile "$INSTDIR\bplc.bat" "@BPL_LIBDIR@" "$INSTDIR"
  Delete "$INSTDIR\bplc.bat.old"

  # write install_dir to registry
  # WriteRegStr HKLM "Software\BPL" "Install_Dir" "$INSTDIR"

  # uninstall keys
  WriteRegStr HKLM \
    "Software\Microsoft\Windows\CurrentVersion\Uninstall\bpl" \
    "DisplayName" "bpl"
  WriteRegStr HKLM \
    "Software\Microsoft\Windows\CurrentVersion\Uninstall\bpl" \
    "UninstallString" '"$INSTDIR\uninstall.exe"'
  WriteRegDWORD HKLM \
    "Software\Microsoft\Windows\CurrentVersion\Uninstall\bpl" \
    "NoModify" 1
  WriteRegDWORD HKLM \
    "Software\Microsoft\Windows\CurrentVersion\Uninstall\bpl" \
    "NoRepair" 1
  WriteUninstaller "uninstall.exe"

SectionEnd

# optional examples

Section "Examples" SecExamples

  SetOutPath $INSTDIR

  File /r Examples

SectionEnd

# optional start menu shortcuts

Section "Start Menu Shortcuts" SecShortcuts

  CreateDirectory "$SMPROGRAMS\BPL"

  CreateShortCut "$SMPROGRAMS\BPL\BPL Interpreter.lnk" \
      "$INSTDIR\bplc.bat" "-i" "$INSTDIR\bplc-bin.exe" 0

  CreateShortCut "$SMPROGRAMS\BPL\Uninstall BPL.lnk" \
    "$INSTDIR\uninstall.exe" "" "$INSTDIR\uninstall.exe" 0

SectionEnd

# uninstaller

Section "Uninstall" SecUninstall

  # registry
  DeleteRegKey HKLM \
    "Software\Microsoft\Windows\CurrentVersion\Uninstall\bpl"
  DeleteRegKey HKLM \
    "Software\bpl"

  # files
  Delete "$INSTDIR\System.bpl"
  Delete "$INSTDIR\bplc-bin.*"
  Delete "$INSTDIR\bplc.*"
  Delete "$INSTDIR\uninstall.exe"

  # shortcuts
  Delete "$SMPROGRAMS\BPL\*.*"

  # directories
  RMDir /r "$INSTDIR\Examples"
  RMDir "$SMPROGRAMS\BPL"
  RMDir "$INSTDIR"

SectionEnd

!insertmacro MUI_FUNCTION_DESCRIPTION_BEGIN
  !insertmacro MUI_DESCRIPTION_TEXT ${SecBPL} "The BPL interpreter and system library."
!insertmacro MUI_FUNCTION_DESCRIPTION_END


